/*
 * @OSF_COPYRIGHT@
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993, 1996 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (DCE).  See the file named COPYRIGHT.DCE in the
 * src directory for the full copyright text.
 * (c) Copyright 1991, 1992 Siemens-Nixdorf Information Systems
 * Burlington, MA, USA
 * All Rights Reserved
 * (c) Copyright 1990, 1991, 1992
 */
/*
 * HISTORY
 * $Log: crrb_exc_001.c,v $
 * Revision 1.1.9.2  1996/02/17  23:29:39  marty
 * 	Update OSF copyright year
 * 	[1996/02/17  22:46:26  marty]
 *
 * Revision 1.1.9.1  1995/12/11  22:57:43  root
 * 	Submit OSF/DCE 1.2.1
 * 	[1995/12/11  22:34:49  root]
 * 
 * Revision 1.1.7.1  1994/04/01  20:08:38  jd
 * 	First code cleanup drop
 * 	[1994/03/28  21:11:53  jd]
 * 
 * Revision 1.1.5.1  1993/10/12  19:34:30  rhw
 * 	Fix for OT8201 - prepend dce to header files
 * 	[1993/10/08  20:29:34  rhw]
 * 
 * Revision 1.1.3.3  1992/12/30  16:28:04  zeliff
 * 	Embedding copyright notice
 * 	[1992/12/30  16:04:47  zeliff]
 * 
 * Revision 1.1.3.2  1992/09/29  20:37:39  devsrc
 * 	[OT 5373]    SNI/SVR4 merge.
 * 	[1992/09/17  20:31:49  sekhar]
 * 
 * Revision 1.1  1992/01/19  03:20:12  devrcs
 * 	Initial revision
 * 
 * $EndLog$
 */
/*
*/
/*
 *  Copyright (c) 1991 by
 *  Digital Equipment Corporation, Maynard Massachusetts.
 *  All rights reserved.
 *
 *  This software is furnished under a license and may be used and copied
 *  only in  accordance  with  the  terms  of  such  license and with the
 *  inclusion of the above copyright notice.  This software or  any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and ownership of  the  software  is hereby
 *  transferred.
 *
 *  The information in this software is subject to change  without notice
 *  and should  not  be  construed  as  a commitment by DIGITAL Equipment
 *  Corporation.
 *
 *  DIGITAL assumes no responsibility for the use or  reliability  of its
 *  software on equipment which is not supplied by DIGITAL.
 */

/*
 *  FACILITY:
 *
 *	CMA Test Programs
 *
 *  FILENAME:
 *
 *	CRRB_EXC_001
 *
 *  TEST TOPICS:
 *
 *	EXC  -  Exceptions
 *
 *  ABSTRACT:
 *
 *	exc_report all messages.  This is most useful in 
 *	determing any problems with Unix messages (or our
 *	VMS equivalent), and if there are any changes in
 *	the dcethreads.cat file which is generated by the
 *	build.
 *
 *  AUTHORS:
 *
 *	Paul Curtin
 *
 *  CREATION DATE:
 *
 *	14 June 1991
 *
 *  MODIFICATION HISTORY:
 *
 */

/*
 *  INCLUDE FILES
 */

#include <dce/cma.h>
#include <dce/cts_test.h>


int
main	(int argc, char *argv[], char *envp[])
    {


    cts_test ("CRRB_EXC_001", "Test EXC messages (Mainly test Unix message work");

    cma_init ();

    printf("\n\n Report all exceptions \n\n");

    exc_report (&exc_e_uninitexc);
    exc_report (&exc_e_illaddr);
    exc_report (&exc_e_exquota);
    exc_report (&exc_e_insfmem);
    exc_report (&exc_e_nopriv);
    exc_report (&exc_e_illinstr);
    exc_report (&exc_e_resaddr);
    exc_report (&exc_e_privinst);
    exc_report (&exc_e_resoper);
    exc_report (&exc_e_SIGTRAP);
    exc_report (&exc_e_SIGIOT);
    exc_report (&exc_e_SIGEMT);
    exc_report (&exc_e_aritherr);
    exc_report (&exc_e_SIGSYS);
    exc_report (&exc_e_SIGPIPE);
    exc_report (&exc_e_excpu);
    exc_report (&exc_e_exfilsiz);
    exc_report (&exc_e_intovf);
    exc_report (&exc_e_intdiv);
    exc_report (&exc_e_fltovf);
    exc_report (&exc_e_fltdiv);
    exc_report (&exc_e_fltund);
    exc_report (&exc_e_decovf);
    exc_report (&exc_e_subrng);
    exc_report (&cma_e_alerted);
    exc_report (&cma_e_assertion);
    exc_report (&cma_e_badparam);
    exc_report (&cma_e_bugcheck);
    exc_report (&cma_e_exit_thread);
    exc_report (&cma_e_existence);
    exc_report (&cma_e_in_use);
    exc_report (&cma_e_use_error);
    exc_report (&cma_e_wrongmutex);
    exc_report (&cma_e_stackovf);
    exc_report (&cma_e_nostackmem);
    exc_report (&cma_e_notcmastack);
    exc_report (&cma_e_unimp);
    exc_report (&cma_e_inialrpro);
    exc_report (&cma_e_defer_q_full);
    exc_report (&cma_e_signal_q_full);
    exc_report (&cma_e_alert_nesting);
#if _CMA_UNIX_TYPE ==  _CMA__SVR4
	exc_report (&exc_e_illopn);
	exc_report (&exc_e_illadr);
	exc_report (&exc_e_illtrp);
	exc_report (&exc_e_prvopc);
	exc_report (&exc_e_prvreg);
	exc_report (&exc_e_coproc);
	exc_report (&exc_e_badstk);
	exc_report (&exc_e_brkpt);
	exc_report (&exc_e_trace);
	exc_report (&exc_e_fltinv);
	exc_report (&exc_e_maperr);
	exc_report (&exc_e_accerr);
	exc_report (&exc_e_adraln);
	exc_report (&exc_e_adrerr);
	exc_report (&exc_e_objerr);
	exc_report (&exc_e_fltres);
#endif /* _CMA_UNIX_TYPE ==  _CMA__SVR4 */

    cts_result ();
    }
/*  DEC/CMS REPLACEMENT HISTORY, Element CRRB_EXC_001.C */
/*  *2    14-JUN-1991 13:17:53 CURTIN "" */
/*  *1    14-JUN-1991 13:05:36 CURTIN "" */
/*  DEC/CMS REPLACEMENT HISTORY, Element CRRB_EXC_001.C */
